
#include <cstdio>
#include <iostream>
using namespace std;

// Converts an RVA to a physical offset.
// Returns 0 on error
unsigned int	rva2phys( FILE * fin, unsigned int uRVA ) {
	unsigned int	uobjsize,uobjRVA,uobjoffset;
	unsigned int	uPEoffset;
	unsigned int	uoffset;
	unsigned int	udata;
	unsigned int	uobjects;
	char		aobjname[9];

	fseek( fin, 0x3c, SEEK_SET );
	fread( &uPEoffset, 4, 1, fin );
	fseek( fin, uPEoffset, SEEK_SET );
	fread( &udata, 4, 1, fin );
	if( udata != 0x004550 ) {
		cout << "ERROR: no PE header" << endl;
		return 0;
	}
	fseek( fin, uPEoffset + 0x06, SEEK_SET );
	uobjects = 0;
	fread( &uobjects, 2, 1, fin );

	fseek( fin, uPEoffset + 0x14, SEEK_SET );
	uoffset = 0;
	fread( &uoffset, 2, 1, fin );
	uoffset += uPEoffset + 0x18;

	for( unsigned int j = 0; j < uobjects; j++ ) {
		//cout << "Searching sections..." << endl;
		aobjname[8] = 0;
		fseek( fin, uoffset, SEEK_SET );
		fread( aobjname, 8, 1, fin );
		fread( &uobjsize, 4, 1, fin );
		fread( &uobjRVA, 4, 1, fin );
		fseek( fin, 4, SEEK_CUR );
		fread( &uobjoffset, 4, 1, fin );
		//printf( "%-8s: 0x%X-0x%X = 0x%X bytes. Physical offset: 0x%X\n", aobjname, uobjRVA, uobjRVA + uobjsize, uobjsize, uobjoffset );
		if( uobjRVA <= uRVA && uobjRVA + uobjsize > uRVA ) {
			break;
		}
		uoffset += 0x28;
	}
	if( j == uobjects ) {
		return 0;
	}

	return uRVA + uobjoffset - uobjRVA;
}
