//
// iceptit v1.00
//
// Replaces some kernel32 functions with its own ones. 
// Can be used to intercept calls to any dll though.
// Just create several iceptit.cc and name the resulting iceptit.dll files 
// differently if you need to replace functions from several dll files at 
// the same time. I haven't tried that, but I can't see why it wouldn't work.
//
// 11 Feb 2000, 25 May 2001, 13 Jul 2002, 30 Nov 2002, Fluff
// 12 Jan 2003, Fluff, Smoothed things up a bit to facilitate a public release.
// 04 Oct 2003, Fluff, Further cleanup.
//
// Mikael Klasson
// mklasson@acm.org
// http://mklasson.cjb.net

#define	WIN32_LEAN_AND_MEAN
#include <windows.h>

// Name of the dll file you're replacing functions in
const char * dll_name = "kernel32.dll";

//*****************************************************************************
// Write your functions below. The included samples should tell you how.
// For each function you want to replace you need to #define FIX_<FunctionName>
// and then write the function fix<FunctionName> with proper declaration.
//*****************************************************************************

#define	FIX_GetVersionExA
BOOL __stdcall fixGetVersionExA( OSVERSIONINFO * p ) {
	BOOL	b;

	b = GetVersionEx( p );

	p->dwMajorVersion = 4;
	p->dwMinorVersion = 0;
	p->dwPlatformId = VER_PLATFORM_WIN32_WINDOWS;

	return b;
}

//#define	FIX_GetUserDefaultLCID
//LCID __stdcall fixGetUserDefaultLCID( void ) {
//	MessageBox( NULL, "beep", "GetUserDefaultLCID", MB_OK );
//	return 0x409;
//}

//#define	FIX_GetDiskFreeSpaceExA
//BOOL __stdcall fixGetDiskFreeSpaceExA(
//		LPCTSTR lpDirectoryName,
//		ULARGE_INTEGER * lpFreeBytesAvailableToCaller,
//		ULARGE_INTEGER * lpTotalNumberOfBytes,
//		ULARGE_INTEGER * lpTotalNumberOfFreeBytes ) {
//	lpFreeBytesAvailableToCaller->QuadPart = 0;
//	lpTotalNumberOfBytes->QuadPart = 0;
//	lpTotalNumberOfFreeBytes->QuadPart = 0;
//
//	return TRUE;
//}

//*****************************************************************************
// End of custom functions. System code below. No need to touch. Move along.
//*****************************************************************************

#include "functions.h"

unsigned int __stdcall DllMain( HANDLE hmain, unsigned int ureason, void * pres ) {
	if( ureason == DLL_PROCESS_ATTACH 
	 || ureason == DLL_THREAD_ATTACH ) {
		for( int u = 0; u < MAX_FUNCS; u++ ) {
			func_ptrs[u] = (unsigned int) GetProcAddress( GetModuleHandle( dll_name ), func_names[u] );
		}
	}

	return TRUE;
}
