//
// Mikael Klasson
// mklasson@acm.org
// http://mklasson.cjb.net
//
// Parses functions.txt and outputs appropriate iceptit.def and functions.h.
//
// 2003-01-12, Fluff, Initial release.
// 2003-10-04, Fluff, Cleanup.

#include <iostream>
#include <fstream>
#include <string>
#include <vector>
using namespace std;

int main( void ) {
	ifstream	fin( "functions.txt" );
	string		name;
	ofstream	fd,fh;
	vector<string>	symbols;

	if( !fin ) {
		cout << "Usage: parse_fnlist" << endl;
		cout << "Parses functions.txt and outputs iceptit.def and functions.h" << endl;
		cout << "Couldn't open functions.txt for reading." << endl;
		return 1;
	}

	fd.open( "iceptit.def", ios_base::out );
	if( !fd.is_open() ) {
		cout << "Couldn't open iceptif.def for writing." << endl;
		return 1;
	}

	fh.open( "functions.h", ios_base::out );
	if( !fh.is_open() ) {
		cout << "Couldn't open functions.h for writing." << endl;
		return 1;
	}

	fd << "EXPORTS" << endl;
	fh << "char * func_names[] = {";
	while( !fin.eof() ) {
		getline( fin, name );
		fin >> ws;
		fd << "\t" << name << "=fix" << name << endl;
		fh << ( symbols.size() ? "," : "" ) << endl << "\t\"" << name << "\"";
		symbols.push_back( name );
	}
	fh << endl << "};" << endl;
	fh << endl << "#define\tMAX_FUNCS\t" << symbols.size() << endl;
	fh << "unsigned int func_ptrs[MAX_FUNCS];" << endl << endl;
	for( unsigned int j = 0; j < symbols.size(); ++j ) {
		fh << "#ifndef\tFIX_" << symbols[j] << endl;
		fh << "\t__declspec(naked) void __stdcall fix" << symbols[j] << "(void){__asm jmp dword ptr func_ptrs[" 
			<< j << " * 4]}" << endl;
		fh << "#endif" << endl;
	}

	fd.close();
	fh.close();
	return 0;
}
